;-------------------------------------------------------------------------------------------------------------
; MOD example installer - (c)2009 TOGCOM.de - The Online Gaming Community
; - This example is fully free and may be used in any way! -
; 
; Author: Jason
; Date  : 06-22-2009
;
; Changes:
;	Huffel - 2011-05-07
;	            * adjusted shortcut parameters to fit the latest changes of patch 33800
;	       - 2011-08-03
;		    * changed registry path to the current one (versions >= community edition)
;-------------------------------------------------------------------------------------------------------------
;
; Use this example script as startingpoint for your own Modification installer
; which installs your requered MOD files this the Soldner - Secret Wars installation
;
;-------------------------------------------------------------------------------------------------------------







;-------------------------------------------------------------
; This macro will held u to show a background screen
;
; Use it this way: BIMAGE [image file name] [options]
;
;-------------------------------------------------------------
!macro BIMAGE IMAGE PARMS
	Push $0
	GetTempFileName $0
	File /oname=$0 "${IMAGE}"
	SetBrandingImage ${PARMS} $0
	Delete $0
	Pop $0
!macroend








; Global defines to specify basics
;--------------------------------------
!define PRODUCT_NAME "Your Mod's name"
!define PRODUCT_VERSION "1.0.00"
!define PRODUCT_PUBLISHER "Yout team's name"
!define PRODUCT_WEB_SITE "http://www.your-site.org"
!define YOUR_MOD_PAK_NAME "your_mod.pak"


;
; Will fix startmenu removal on deinstall
; Else start menu entries are first
; removed after reboot on Vista!
;
; Note: Requeres the installer to run on
;       admin level (UAC)
;--------------------------------------
!define VISTA_FIX


; You might never change this...
;--------------------------------------
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"





; Here the compression algo is set
; Also some other basics (if wanted)
;--------------------------------------
SetCompressor lzma
BrandingText "${PRODUCT_PUBLISHER}"


; Set this for full screen background gradient
;-------------------------------------------------
BGGradient 0000FF 000000 FFFFFF


; If vista and UAC is enabled and amin is requered
;-------------------------------------------------
!ifdef VISTA_FIX
RequestExecutionLevel admin
!endif






; MUI 1.67 compatible ------
!include "MUI.nsh"


; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"


; Language Selection Dialog Settings
!define MUI_LANGDLL_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_LANGDLL_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_LANGDLL_REGISTRY_VALUENAME "NSIS:Language"


; Welcome page
!insertmacro MUI_PAGE_WELCOME


; License page (If wanted)
;!define MUI_LICENSEPAGE_CHECKBOX
;!insertmacro MUI_PAGE_LICENSE "your_license.txt"


; Directory page
!insertmacro MUI_PAGE_DIRECTORY


; Components page
!insertmacro MUI_PAGE_COMPONENTS


; Instfiles page
!insertmacro MUI_PAGE_INSTFILES


; Finish page
!insertmacro MUI_PAGE_FINISH


; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES


; Language files
; Select all languages you want to include)
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "French"
!insertmacro MUI_LANGUAGE "German"
!insertmacro MUI_LANGUAGE "Italian"
!insertmacro MUI_LANGUAGE "Japanese"
!insertmacro MUI_LANGUAGE "Polish"
!insertmacro MUI_LANGUAGE "Russian"
!insertmacro MUI_LANGUAGE "Spanish"


; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------






;------------------------------------------------------------------
; Setup name of Mod and set outfile name as well as path
;------------------------------------------------------------------
Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "your_mods_name.exe"
InstallDir "$PROGRAMFILES\Your Mod"
ShowInstDetails show
ShowUnInstDetails show





;----------------------------------------------------------------------------------------------
/* initfunction */
;----------------------------------------------------------------------------------------------
Function .onInit
  
  ;----------------------------------------------------------------------------------------------
  ; Check registry for soldner-path
  ;----------------------------------------------------------------------------------------------
;Old registry path for versions before community edition:
;ReadRegStr $0 HKLM "SOFTWARE\Jowood\Portal\soeldner" "path"
; New path:
  ReadRegStr $0 HKLM "SOFTWARE\SoldnerSecretWars" "path"
  StrLen $1 $0
  IntCmp $1 0 no_soldner
  StrCpy $INSTDIR "$0"
  
  !insertmacro MUI_LANGDLL_DISPLAY
  Return


  ;----------------------------------------------------
  ; ERROR CONDITION: Soldner not found
  ;----------------------------------------------------
no_soldner:
  MessageBox MB_OK "Soldner Secret was not found on this computer"
  Quit

FunctionEnd












Section "-NMOD" SEC01

  ; Set output path
  ; only overwrite if newer
  ; and finaly install your mod PAK file
  ;------------------------------------------------------------
  CreateDirectory "$INSTDIR\game\mods"
  SetOutPath "$INSTDIR\game\mods"
  SetOverwrite ifnewer
  File ".\${YOUR_MOD_PAK_NAME}"

SectionEnd



Section "Startmenu entries" SEC02
!ifdef VISTA_FIX
  SetShellVarContext all
!endif

  CreateDirectory "$INSTDIR\game\mods\$(^Name)"
  CreateDirectory "$SMPROGRAMS\${PRODUCT_NAME}"
  WriteIniStr "$INSTDIR\game\mods\$(^Name)\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  SetOutPath "$INSTDIR\game\Bin"
  CreateShortCut "$SMPROGRAMS\${PRODUCT_NAME}\Your_Mod.lnk" "$INSTDIR\game\Bin\SoeldnerSecretWars.exe" "-user:Client -uncertified -ignoreregistrypath -mods:${YOUR_MOD_PAK_NAME}"
  SetOutPath "$SMPROGRAMS\${PRODUCT_NAME}"
  CreateShortCut "$SMPROGRAMS\${PRODUCT_NAME}\Website.lnk" "$INSTDIR\game\mods\$(^Name)\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\${PRODUCT_NAME}\Uninstall.lnk" "$INSTDIR\game\mods\$(^Name)\uninst.exe"
  ;CreateShortCut "$SMPROGRAMS\${PRODUCT_NAME}\readme.lnk" "$INSTDIR\game\mods\$(^Name)\readme.txt"
  ;CreateShortCut "$SMPROGRAMS\${PRODUCT_NAME}\changelog.lnk" "$INSTDIR\game\mods\$(^Name)\changelog.txt"
  SetOutPath "$INSTDIR"
SectionEnd




Section -Post
  CreateDirectory "$INSTDIR\game\mods\$(^Name)"
  WriteUninstaller "$INSTDIR\game\mods\$(^Name)\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\game\mods\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd

; Section descriptions
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} "Requered components"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} "Startmenu entries like: changelog, webpage etc..."
!insertmacro MUI_FUNCTION_DESCRIPTION_END






Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "Your Mod successfully uninstalled"
FunctionEnd

Function un.onInit
!insertmacro MUI_UNGETLANGUAGE
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Do you wish to uninstall Your Mod?" IDYES +2
  Abort
FunctionEnd






Section Uninstall

 
  ;-----------------------------------------------------------------------------------------------------------------
  ; Encounter filename and uninstall files
  ;-----------------------------------------------------------------------------------------------------------------
  Delete "$INSTDIR\..\${YOUR_MOD_PAK_NAME}"
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\readme.txt"
  Delete "$INSTDIR\changelog.txt"


  ;-----------------------------------------------------------------------------------------------------------------
  ; Remove start-menu entries
  ;-----------------------------------------------------------------------------------------------------------------
!ifdef VISTA_FIX
  SetShellVarContext all
!endif

  RMDir /r "$SMPROGRAMS\${PRODUCT_NAME}"
  RMDir "$INSTDIR\..\$(^Name)"

  SetAutoClose true
  Return

SectionEnd
